diff -uNr trunk-r680/encoder/encoder.c trunk/encoder/encoder.c
--- trunk-r680/encoder/encoder.c	2007-09-24 11:24:28.000000000 +0400
+++ trunk/encoder/encoder.c	2007-10-16 16:03:25.097907200 +0400
@@ -615,7 +615,7 @@
     x264_reduce_fraction( &h->param.i_fps_num, &h->param.i_fps_den );
 
     /* Init x264_t */
-    h->i_frame = 0;
+    h->i_frame = -1;
     h->i_frame_num = 0;
     h->i_idr_pic_id = 0;
 
@@ -938,9 +938,6 @@
 {
     int i;
 
-    if( h->fdec->i_frame >= 0 )
-        h->i_frame++;
-
     if( !h->fdec->b_kept_as_ref )
     {
         if( h->param.i_threads > 1 )
@@ -1310,6 +1307,7 @@
         }
     }
 
+    h->i_frame++;
     if( h->frames.current[0] == NULL )
     {
         int bframes = 0;
@@ -1772,6 +1770,17 @@
             x264_pthread_join( h->thread[i]->thread_handle, NULL );
     }
 
+    if( h->param.i_threads > 1)
+    {
+        x264_t *thread_prev;
+
+        thread_prev = h->thread[ h->i_thread_phase % h->param.i_threads ];
+        x264_thread_sync_ratecontrol( h, thread_prev, h );
+        x264_thread_sync_ratecontrol( thread_prev, thread_prev, h );
+        h->i_frame = thread_prev->i_frame + 1 - h->param.i_threads;
+    }
+    h->i_frame++;
+
 #ifdef DEBUG_BENCHMARK
     x264_log( h, X264_LOG_INFO,
               "analyse=%d(%lldms) encode=%d(%lldms) write=%d(%lldms) filter=%d(%lldms)\n",